﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Security.Cryptography;
using System.Text;
using System.Threading.Tasks;

namespace EncryptFileDESSample
{
    class Program
    {
        static void Main(string[] args)
        {
            string inputFile = "GeheimeDatei.txt";
            string outputFileEncrypted = @"c:\Temp\GeheimeDateiVerschluesselt.txt";
            string outputFileDecrypted = @"c:\Temp\GeheimeDateiEntschluesselt.txt";
            string key = @"HierDerGeheimeKey";

            EncryptFile(inputFile, outputFileEncrypted, key);

            DecryptFile(outputFileEncrypted, outputFileDecrypted, key);
        }

        ///<summary>
        /// Datei mit dem DES-Algorithmus verschlüsseln
        ///</summary>
        ///<param name="inputFile">Zu verschlüsselnde Datei</param>
        ///<param name="outputFile">Neue verschlüssselte Datei</param>
        ///<param name="key">Key mit dem verschlüsselt wird</param>
        private static void EncryptFile(string inputFile, string outputFile, string key)
        {
            try
            {
                byte[] k = Encoding.ASCII.GetBytes(key);

                string cryptFile = outputFile;
                DESCryptoServiceProvider des = new DESCryptoServiceProvider();
                des.KeySize = 128;

                using (FileStream fsCrypt = new FileStream(cryptFile, FileMode.Create))
                {
                    using (CryptoStream cs = new CryptoStream(fsCrypt, des.CreateEncryptor(k, k), CryptoStreamMode.Write))
                    {
                        using (FileStream fsIn = new FileStream(inputFile, FileMode.Open))
                        {
                            int data;
                            while ((data = fsIn.ReadByte()) != -1)
                            {
                                cs.WriteByte((byte)data);
                            }
                        }
                    }
                }
            }
            catch (Exception ex)
            {
                Console.WriteLine("Verschlüsselung fehlgeschlagen!");
                Console.WriteLine($"Fehler: {ex.Message}");
            }
        }

        ///<summary>
        /// Verschlüsselte Datei mit dem DES-Algorithmus entschlüsseln
        ///</summary>
        ///<param name="inputFile">Die verschlüsselte Datei</param>
        ///<param name="outputFile">Neue entschlüsselte Datei</param>
        ///<param name="key">Key mit dem verschlüsselt wurde</param>
        private static void DecryptFile(string inputFile, string outputFile, string key)
        {
            try
            {
                byte[] k = Encoding.ASCII.GetBytes(key);

                DESCryptoServiceProvider des = new DESCryptoServiceProvider();

                using (FileStream fsCrypt = new FileStream(inputFile, FileMode.Open))
                {
                    using (CryptoStream cs = new CryptoStream(fsCrypt, des.CreateDecryptor(k, k), CryptoStreamMode.Read))
                    {
                        using (FileStream fsOut = new FileStream(outputFile, FileMode.Create))
                        {
                            int data;
                            while ((data = cs.ReadByte()) != -1)
                            {
                                fsOut.WriteByte((byte)data);
                            }
                        }
                    }
                }
            }
            catch (Exception ex)
            {
                Console.WriteLine("Entschlüsselung fehlgeschlagen!");
                Console.WriteLine($"Fehler: {ex.Message}");
            }
        }
    }
}
