﻿using System;
using System.IO;
using System.Security.Cryptography;
using System.Text;

namespace EncryptFileMoreAdvanced
{
    class Program
    {
        static void Main(string[] args)
        {
            string inputFile = "GeheimeDatei.txt";
            string outputFileEncrypted = @"c:\Temp\GeheimeDateiVerschluesselt.txt";
            string outputFileDecrypted = @"c:\Temp\GeheimeDateiEntschluesselt.txt";
            string password = @"myKey123";

            EncryptFile(inputFile, outputFileEncrypted, password);

            DecryptFile(outputFileEncrypted, outputFileDecrypted, password);
        }

        ///<summary>
        /// Datei mit dem Rijndael-Algorithmus verschlüsseln
        ///</summary>
        ///<param name="inputFile">Zu verschlüsselnde Datei</param>
        ///<param name="outputFile">Neue verschlüssselte Datei</param>
        ///<param name="outputFile">Passwort mit dem verschlüsselt wird</param>
        private static void EncryptFile(string inputFile, string outputFile, string password)
        {
            try
            {              
                UnicodeEncoding enc = new UnicodeEncoding();
                byte[] key = enc.GetBytes(password);

                string cryptFile = outputFile;
                RijndaelManaged RMCrypto = new RijndaelManaged();

                using (FileStream fsCrypt = new FileStream(cryptFile, FileMode.Create))
                {
                    using (CryptoStream cs = new CryptoStream(fsCrypt, RMCrypto.CreateEncryptor(key, key), CryptoStreamMode.Write))
                    {
                        using (FileStream fsIn = new FileStream(inputFile, FileMode.Open))
                        {
                            int data;
                            while ((data = fsIn.ReadByte()) != -1)
                            {
                                cs.WriteByte((byte)data);
                            }
                        }
                    }
                }
            }
            catch (Exception ex)
            {
                Console.WriteLine("Verschlüsselung fehlgeschlagen!");
                Console.WriteLine($"Fehler: {ex.Message}");
            }
        }

        ///<summary>
        /// Verschlüsselte Datei mit dem Rijndael-Algorithmus entschlüsseln
        ///</summary>
        ///<param name="inputFile">Die verschlüsselte Datei</param>
        ///<param name="outputFile">Neue entschlüsselte Datei</param>
        ///<param name="outputFile">Passwort mit dem verschlüsselt wurde</param>
        private static void DecryptFile(string inputFile, string outputFile, string password)
        {
            try
            {
                UnicodeEncoding enc = new UnicodeEncoding();
                byte[] key = enc.GetBytes(password);

                RijndaelManaged RMCrypto = new RijndaelManaged();

                using (FileStream fsCrypt = new FileStream(inputFile, FileMode.Open))
                {
                    using (CryptoStream cs = new CryptoStream(fsCrypt, RMCrypto.CreateDecryptor(key, key), CryptoStreamMode.Read))
                    {
                        using (FileStream fsOut = new FileStream(outputFile, FileMode.Create))
                        {
                            int data;
                            while ((data = cs.ReadByte()) != -1)
                            {
                                fsOut.WriteByte((byte)data);
                            }
                        }
                    }
                }
            }
            catch (Exception ex)
            {
                Console.WriteLine("Entschlüsselung fehlgeschlagen!");
                Console.WriteLine($"Fehler: {ex.Message}");
            }
        }
    }
}
