﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Runtime.Serialization;
using System.Runtime.Serialization.Formatters.Binary;

namespace BinaryFormatterSample01
{
    class Program
    {
        static void Main(string[] args)
        {
            string saveFile = @"c:\Temp\DataFile.dat";

            Friend myFriend = new Friend()
            {
                Nachname = "Mustermann",
                Vorname = "Max",
                EMail = "mail@not.set",
                Geburtsdatum = DateTime.Now
            };

            // BinaryFormatter-Objekt zum Serialisieren erzeugen
            BinaryFormatter formatter = new BinaryFormatter();

            // Stream zum speichern in eine Datei
            using (FileStream fs = new FileStream(saveFile, FileMode.OpenOrCreate))
            {
                formatter.Serialize(fs, myFriend);
            }

            using (FileStream fs = new FileStream(saveFile, FileMode.Open))
            {
                Friend f = (Friend)formatter.Deserialize(fs);
            }
        }
    }

    [Serializable] 
    public class Friend
    {
        public string Vorname { get; set; }
        public string Nachname { get; set; }
        public string EMail { get; set; }
        public DateTime Geburtsdatum { get; set; } 
    }
}
