﻿using System;
using System.IO;
using System.Runtime.Serialization.Json;

namespace JsonSerializerSample01
{
    class Program
    {
        static void Main(string[] args)
        {
            string saveFile = @"c:\Temp\Friends.json";

            Friend myFriend = new Friend()
            {
                Nachname = "Mustermann",
                Vorname = "Max",
                EMail = "mail@not.set",
                Geburtsdatum = DateTime.Now
            };

            // JsonSerializer-Objekt zum Serialisieren erzeugen
            // Serializer erwartet den Typ, welcher serialisiert bzw.
            // deserialisiert werden soll!
            DataContractJsonSerializer js = new DataContractJsonSerializer(typeof(Friend));

            // Stream zum speichern in eine Datei
            using (FileStream fs = new FileStream(saveFile, FileMode.OpenOrCreate))
            {
                js.WriteObject(fs, myFriend);
            }

            using (FileStream fs = new FileStream(saveFile, FileMode.Open))
            {
                Friend f = (Friend)js.ReadObject(fs);
            }
        }
    }

    [Serializable]
    public class Friend
    {
        public string Vorname { get; set; }
        public string Nachname { get; set; }
        public string EMail { get; set; }
        public DateTime Geburtsdatum { get; set; }
    }
}
