﻿using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace JsonSerializerSample02
{
    class Program
    {
        static void Main(string[] args)
        {
            string saveFile = @"c:\Temp\Friends.json";

            Friend myFriend = new Friend()
            {
                Nachname = "Mustermann",
                Vorname = "Max",
                EMail = "mail@not.set",
                Geburtsdatum = DateTime.Now
            };

            // JsonSerializer-Instanz erstellen
            JsonSerializer jsonSerializer = new JsonSerializer();

            // Stream zum speichern in eine Datei
            using (StreamWriter sw = File.CreateText(saveFile))
            {
                jsonSerializer.Serialize(sw, myFriend);
            }

            // Json-Datei wieder einlesen
            using (StreamReader sr = File.OpenText(saveFile))
            {
                Friend friend = (Friend)jsonSerializer.Deserialize(sr, typeof(Friend));
            }
        }
    }

    [JsonObject(MemberSerialization.OptIn)]
    public class Friend
    {
        [JsonProperty]
        public string Vorname { get; set; }
        [JsonProperty]
        public string Nachname { get; set; }
        [JsonProperty]
        public string EMail { get; set; }
        [JsonProperty]
        public DateTime Geburtsdatum { get; set; }
    }
}
