﻿using System;
using System.IO;
using System.Text;

namespace StreamSample02
{
    class Program
    {
        public static void Main()
        {
            string path = @"c:\temp\MyTest.txt";
            UTF8Encoding enc = new UTF8Encoding(true);

            // Datei löschen, falls sie existiert
            if (File.Exists(path))
            {
                File.Delete(path);
            }

            // Datei erzeugen
            using (FileStream fs = File.Create(path))
            {                
                byte[] bytesToWrite;

                // Text in den Stream schreiben
                bytesToWrite = enc.GetBytes("Hier steht Beispieltext.");
                fs.Write(bytesToWrite, 0, bytesToWrite.Length);

                // Noch etwas mehr Text in den Stream schreiben
                bytesToWrite = enc.GetBytes("Hier steht noch etwas mehr Beispieltext!");
                fs.Write(bytesToWrite, 0, bytesToWrite.Length);
                
                // Zum Abschluss noch eine neue Zeile
                bytesToWrite = enc.GetBytes("\r\nJetzt komm eine neue Zeile.");
                fs.Write(bytesToWrite, 0, bytesToWrite.Length);
            }

            // Datei mit Stream öffen und ausgeben
            using (FileStream fs = File.OpenRead(path))
            {
                // Byte-Array in welches die Bytes des Streams
                // gelesen werden (Puffer)
                byte[] b = new byte[fs.Length];

                // FileStream in Schleife bis zum Ende lesen
                while (fs.Read(b, 0, (int)fs.Length) > 0)
                {
                    Console.WriteLine(enc.GetString(b));
                }

                Console.ReadKey();
            }
        }
    }
}
