﻿using System;
using System.IO;
using System.Xml.Serialization;

namespace XmlSerializer01
{
    class Program
    {
        static void Main(string[] args)
        {
            string fileName = @"C:\Temp\Friends.xml";

            Friend myFriend = new Friend()
            {
                Vorname = "Max",
                Nachname = "Mustermann",
                EMail = "mail@not.set",
                Geburtsdatum = DateTime.Now
            };

            XmlSerializer xs = new XmlSerializer(typeof(Friend));

            using (Stream fs = File.OpenWrite(fileName))
            {
                xs.Serialize(fs, myFriend);
            }

            using (Stream fs = File.OpenRead(fileName))
            {
                Friend f = (Friend)xs.Deserialize(fs);
            }
        }
    }

    [Serializable]
    public class Friend
    {
        public string Vorname { get; set; }
        public string Nachname { get; set; }
        public string EMail { get; set; }
        [NonSerialized]
        private DateTime geburtsdatum;
        public DateTime Geburtsdatum
        {
            get { return this.geburtsdatum; }
            set { this.geburtsdatum = value; }
        }
    }
}
