﻿using System.IO;
using System.IO.Compression;

namespace ZipArchiveSample01
{
    class Program
    {
        static void Main(string[] args)
        {
            string zipFile = @"c:\Temp\release.zip";

            // FileStream-Objekt erzeugen
            using (FileStream zipToOpen = new FileStream(zipFile, FileMode.OpenOrCreate))
            {
                // ZIP-Archiv erzeugen
                using (ZipArchive archive = new ZipArchive(zipToOpen, ZipArchiveMode.Update))
                {
                    // Neuen Eintrag hinzufügen
                    ZipArchiveEntry readmeEntry = archive.CreateEntry("Readme.txt");
                    // Text in die neu erzeuge Datei schreiben
                    using (StreamWriter writer = new StreamWriter(readmeEntry.Open()))
                    {
                        writer.WriteLine("Informationen zu diesem Archiv!");
                        writer.WriteLine("========================");
                    }
                }
            }
        }
    }
}
