﻿using System;
using System.IO;
using System.IO.Compression;

namespace ZipArchiveSample02
{
    class Program
    {
        static void Main(string[] args)
        {
            string zipPath = @"C:\Temp\release.zip";
            string extractPath = @"C:\Temp";

            // Sicherstellen, dass letztes Zeichen ein Pfadtrenner ist
            // wenn nicht könnte es passieren, dass die ZIP-Datei im
            // übergeordneten Verzeichnis extrahiert wird
            if (!extractPath.EndsWith(Path.DirectorySeparatorChar.ToString(), StringComparison.Ordinal))
                extractPath += Path.DirectorySeparatorChar;

            using (ZipArchive archive = ZipFile.OpenRead(zipPath))
            {
                foreach (ZipArchiveEntry entry in archive.Entries)
                {
                    // Vollen Dateipfad ermitteln für die Extraktion
                    // ermitteln
                    string destinationPath = Path.GetFullPath(Path.Combine(extractPath, entry.FullName));

                    if (destinationPath.StartsWith(extractPath, StringComparison.Ordinal))
                        entry.ExtractToFile(destinationPath);
                }
            }
        }
    }
}
