﻿using System;
using System.Threading.Tasks;

namespace TaskSample03
{
    class Program
    {
        static void Main()
        {
            // Task starten
            Task.Run<long>(() => {
                return DoWork("0");
            }).ContinueWith((t1) => {
                PrintResult(t1, "Print 0");
                Task.Run<long>(() => {                    
                    return DoWork("1");
                }).ContinueWith((t2) => {
                    PrintResult(t2, "Print 1");
                });
            });

            Console.ReadKey();
        }

        static long DoWork(object data)
        {
            // Stopwatch für die Zeitmessung
            System.Diagnostics.
                Stopwatch s = new System.Diagnostics.Stopwatch();

            // Zeitmessung starten
            s.Start();

            // Arbeit erledigen
            for (int i = 0; i < 1000; i++)
            {
                Console.Write(data);
            }

            // Zeimessunge anhalten
            s.Stop();

            // Ergebnis Zeitmessung zurückgeben
            return s.ElapsedMilliseconds;
        }

        static void PrintResult(Task<long> t, string taskName)
        {
            System.Diagnostics.
                Debug.WriteLine($"'{taskName}' needed {t.Result} ms for execution!");
        }
    }
}
