﻿using System;
using System.Threading;

namespace ThreadAbortSample01
{
    class Program
    {
        static void Main(string[] args)
        {
            Thread myThread = new Thread(new ThreadStart(ThreadWork.DoWork));
            myThread.Start();
            Thread.Sleep(300);

            Console.WriteLine("Main - Thread abbrechen!");
            myThread.Abort();
            myThread.Join();

            Console.WriteLine("Programm beendet ...");

            Console.Read();
        }
    }

    public class ThreadWork
    {
        public static void DoWork()
        {
            try
            {
                for (int i = 0; i < 100; i++)
                {
                    Console.WriteLine("Thread - arbeitet ...");
                    Thread.Sleep(100);
                }
            }
            catch (ThreadAbortException e)
            {
                Console.WriteLine("Thread hat Ausnahme verusacht!");
                Console.WriteLine($"Nachricht: {e.Message}");
                // Thread.ResetAbort();
            }
            finally
            {
                // Breinigungsarbeiten
            }

            // Wenn hier noch Code steht wird dieser nicht
            // ausgeführt! Außer im catch-Block wird die
            // Thread.ResetAbort()-Methode aufgerufen!
            Console.WriteLine("Thread - Arbeit beendet!");
        }
    }
}
