﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace LinqToObjects
{
    public class OrderService
    {
        public OrderService()
        {
            // Liste mit Produkten initialisieren
            InitProducts();
            // Liste mit Aufträgen initialisieren
            InitOrderList();
            // Liste mit Kunden initialisieren
            InitCustomerList();
        }

        private void InitCustomerList()
        {
            Customers = new List<Customer>();

            Customers.Add(new Customer()
            {
                CustomerId = 1,
                FirstName = "Steffen",
                LastName = "Steinbrecher",
                Street = "Musterstrasse 11",
                City = "Musterstadt",
                Postcode = "12345",
                Country = "Germany",
                Orders = new List<Order>() { Orders[0], Orders[1] }
            });
            Customers.Add(new Customer()
            {
                CustomerId = 2,
                FirstName = "Max",
                LastName = "Mustermann",
                Street = "Hirschstrasse 11",
                City = "Hamburg",
                Postcode = "89642",
                Country = "Germany",
                Orders = new List<Order>() { Orders[2], Orders[3], Orders[4] }
            });
            Customers.Add(new Customer()
            {
                CustomerId = 3,
                FirstName = "Harry",
                LastName = "Hirsch",
                Street = "Dorfstrasse 8",
                City = "München",
                Postcode = "98547",
                Country = "Germany",
                Orders = new List<Order>() { Orders[5] }
            });
            Customers.Add(new Customer()
            {
                CustomerId = 4,
                FirstName = "Klaus",
                LastName = "Müller",
                Street = "Hauptstrasse 118",
                City = "Musterstadt",
                Postcode = "12345",
                Country = "Germany",
                Orders = new List<Order>() { Orders[6], Orders[7] }
            });
            Customers.Add(new Customer()
            {
                CustomerId = 5,
                FirstName = "Martin",
                LastName = "Müller",
                Street = "Am Eck 12",
                City = "Musterstadt",
                Postcode = "12345",
                Country = "Germany",
                Orders = new List<Order>() { Orders[8], Orders[9], Orders[10] }
            });
        }

        private void InitOrderList()
        {
            Orders = new List<Order>()
            {
               new Order() { OrderId = 1, OrderDate = new DateTime(2019, 3, 8),
                             Shipped = true, ShippingDate = new DateTime(2019, 3, 8),
                             Total = 449.00 },
               new Order() { OrderId = 2, OrderDate = new DateTime(2019, 3, 20), Shipped = true, ShippingDate = new DateTime(2019, 3, 22), Total = 360.49 },
               new Order() { OrderId = 3, OrderDate = new DateTime(2019, 4, 3), Shipped = true, ShippingDate = new DateTime(2019, 4, 4), Total = 450.90 },
               new Order() { OrderId = 4, OrderDate = new DateTime(2019, 4, 27), Shipped = true, ShippingDate = new DateTime(2019, 4, 27), Total = 901.80 },
               new Order() { OrderId = 5, OrderDate = new DateTime(2019, 4, 23), Shipped = true, ShippingDate = new DateTime(2019, 4, 27), Total = 499.99 },
               new Order() { OrderId = 6, OrderDate = new DateTime(2019, 5, 1), Shipped = true, ShippingDate = new DateTime(2019, 5, 2), Total = 399.00 },
               new Order() { OrderId = 7, OrderDate = new DateTime(2019, 5, 16), Shipped = true, ShippingDate = new DateTime(2019, 5, 23), Total = 315.49 },
               new Order() { OrderId = 8, OrderDate = new DateTime(2019, 6, 11), Shipped = true, ShippingDate = new DateTime(2019, 6, 11), Total = 898.00 },
               new Order() { OrderId = 9, OrderDate = new DateTime(2019, 6, 25), Shipped = true, ShippingDate = new DateTime(2019, 6, 25), Total = 898.00 },
               new Order() { OrderId = 10, OrderDate = new DateTime(2019, 6, 27), Shipped = true, ShippingDate = new DateTime(2019, 6, 27), Total = 298.98 },
               new Order() { OrderId = 11, OrderDate = new DateTime(2019, 6, 28), Shipped = true, ShippingDate = new DateTime(2019, 6, 28), Total = 449.00 } };
        }

        private void InitProducts()
        {
            Products = new List<Product>()
                        {
                            new Product() { ProductId = 1, Name = "Huawai P10", Price = 315.49 },
                            new Product() { ProductId = 2, Name = "Huawai P9", Price = 298.98 },
                            new Product() { ProductId = 3, Name = "Apple Iphone 6", Price = 360.49 },
                            new Product() { ProductId = 4, Name = "Apple Iphone 6 Plus", Price = 399.99 },
                            new Product() { ProductId = 5, Name = "Apple Iphone 7", Price = 450.90 },
                            new Product() { ProductId = 6, Name = "Apple Iphone 7 Plus", Price = 499.99 },
                            new Product() { ProductId = 7, Name = "Samsung Galaxy S7", Price = 399.00 },
                            new Product() { ProductId = 8, Name = "Samsung Galayy S8", Price = 449.00 }
                        };
        }

        /// <summary>
        /// List with customers
        /// </summary>
        public IList<Customer> Customers { get; private set; }

        /// <summary>
        /// List with orders
        /// </summary>
        public IList<Order> Orders { get;  private set; }

        /// <summary>
        /// Liste mit Produkten
        /// </summary>
        public List<Product> Products { get;  private set; }
    }
}