﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace LinqToObjects
{
    class Program
    {
        static void Main(string[] args)
        {
            var orderService = new OrderService();

            // Abfragesyntax
            double sum1 =
                (from o in orderService.Orders
                 where o.OrderDate.Month == 6
                 select o.Total)
                .Sum();

            // Methodensyntax
            double sum2 = orderService.Orders
                .Where(o => o.OrderDate.Month == 6)
                .Sum(o => o.Total);

            Console.WriteLine("Ergebnis Abfragesyntax:");

            // Ergebnis der Abfragesyntax
            //foreach (var c in orders1)
            //{
            //    Console.WriteLine($"Nachname = {c.LastName}, Vorname = {c.FirstName}, PLZ = {c.Postcode}, Ort = {c.City}");
            //}

            Console.WriteLine(System.Environment.NewLine);

            Console.WriteLine("Ergebnis Methodensyntax:");

            // Ergebnis Methodensyntax
            //foreach (var c in customers2)
            //{
            //    Console.WriteLine($"Nachname = {c.LastName}, Vorname = {c.FirstName}, PLZ = {c.Postcode}, Ort = {c.City}");
            //}

            System.Console.ReadKey();
        }
    }
}
