﻿using System;
using System.Data.Common;

namespace ADONetAsyncSample01
{
    public static class DbDataReaderExtensions
    {
        public static T GetFieldValue<T>(this DbDataReader reader, string fieldName, T defaultValue = default(T))
        {
            try
            {
                var value = reader[fieldName];
                if (value == DBNull.Value || value == null)
                    return defaultValue;
                return (T)value;
            }
            catch (Exception e)
            {
                System.Diagnostics.Debug.WriteLine($"Datebankfeld {fieldName} kann nicht gelese werden: {e}");
            }

            return defaultValue;
        }
    }
}
