﻿using Npgsql;
using System;
using System.Collections.Generic;
using System.Data.Common;
using System.Threading.Tasks;

namespace ADONetAsyncSample01
{
    class Program
    {
        static string connString = "Host=localhost;Username=postgres;Password=postgres;Database=Northwind";

        static async Task Main(string[] args)
        {
            foreach (var o in await GetAllOrders())
            {
                Console.WriteLine(o.ToString());
            }

            Console.ReadKey();
        }

        static async Task<IList<Order>> GetAllOrders()
        {
            IList<Order> result = new List<Order>();

            string command =
              "SELECT customer_id, order_date, shipped_date, freight," +
              "       ship_name, ship_address, ship_city, ship_postal_code, " +
              "       ship_country " +
              "FROM orders " +
              "ORDER BY customer_id;";


            using (NpgsqlConnection conn = new NpgsqlConnection(connString))
            {
                await conn.OpenAsync();

                NpgsqlCommand cmd = new NpgsqlCommand(command, conn);

                using (DbDataReader r = await cmd.ExecuteReaderAsync())
                {
                    while (await r.ReadAsync())
                    {
                        var order = new Order();
                        order.CustomerId = r.GetFieldValue<string>("customer_id");
                        order.OrderDate = r.GetFieldValue<DateTime>("order_date");
                        order.ShippedDate = r.GetFieldValue<DateTime>("shipped_date");
                        order.Freight = r.GetFieldValue<float>("freight");
                        order.ShipName = r.GetFieldValue<string>("ship_name");
                        order.ShipAddress = r.GetFieldValue<string>("ship_address");
                        order.ShipCity = r.GetFieldValue<string>("ship_city");
                        order.ShipPostalCode = r.GetFieldValue<string>("ship_postal_code");
                        order.ShipCountry = r.GetFieldValue<string>("ship_country");

                        result.Add(order);
                    }
                }
            }

            return result;
        }
    }
}
