﻿using Npgsql;
using System;

namespace ADONetSample02
{
    class Program
    {
        static void Main(string[] args)
        {
            string connString = "Host=localhost;Username=postgres;Password=postgres;Database=Northwind";

            using (var conn = new NpgsqlConnection(connString))
            {
                // Verbindung zur Datenbank öffnen
                conn.Open();

                // Retrieve all rows
                using (var cmd = new NpgsqlCommand("SELECT category_id, category_name, description FROM categories", conn))
                {
                    using (var reader = cmd.ExecuteReader())
                    {
                        while (reader.Read())
                        {                            
                            // Wichtig ist, dass die Spalten in der Reihenfolge
                            // wie sie im SELECT-Befehl stehen gelesen werden (Index)
                            // Außerdem muss man auf den richtigen Datentyp achten!
                            Category cat = new Category();
                            cat.Id = reader.GetInt32(0);
                            cat.Name = reader.GetString(1);
                            cat.Description = reader.GetString(2);

                            Console.WriteLine($"{cat.Id} | {cat.Name} | {cat.Description}");
                        }

                        reader.Close();
                    }
                }
            }

            Console.ReadKey();
        }
    }

    public class Category
    {
        public int Id { get; set; }
        public string Name { get; set; }
        public string Description { get; set; }
    }
}
