﻿using Npgsql;
using System;

namespace ADONetSample03
{
    class Program
    {
        static void Main(string[] args)
        {
            string connString = "Host=localhost;Username=postgres;Password=postgres;Database=Northwind";

            string insertStmt = "INSERT INTO categories (category_id, category_name, description)" +
                                "VALUES (@category_id, @category_name, @description)";

            using (var conn = new NpgsqlConnection(connString))
            {
                // Verbindung zur Datenbank öffnen
                conn.Open();

                // Command erzeugen
                using (var cmd = new NpgsqlCommand(insertStmt, conn))
                {
                    // Command mit Parametern versorgen
                    cmd.Parameters.AddWithValue("category_id", 9);
                    cmd.Parameters.AddWithValue("category_name", "Neue Kategorie");
                    cmd.Parameters.AddWithValue("description", "Meine neue Kategorie");

                    // Command ausführen
                    cmd.ExecuteNonQuery();
                }
            }

            Console.ReadKey();
        }
    }
}
