﻿using Npgsql;
using System;

namespace ADONetSample04
{
    class Program
    {
        static void Main(string[] args)
        {
            string connString = "Host=localhost;Username=postgres;Password=postgres;Database=Northwind";

            string updateStmt = "UPDATE categories " +
                                "SET category_name = @category_name, " +
                                "    description = @description " +
                                "WHERE category_id = @category_id";

            using (var conn = new NpgsqlConnection(connString))
            {
                // Verbindung zur Datenbank öffnen
                conn.Open();

                // Command erzeugen
                using (var cmd = new NpgsqlCommand(updateStmt, conn))
                {
                    // Command mit Parametern versorgen
                    cmd.Parameters.AddWithValue("category_id", 9);
                    cmd.Parameters.AddWithValue("category_name", "Garten");
                    cmd.Parameters.AddWithValue("description", "Alles für den Garten");

                    // Command ausführen
                    cmd.ExecuteNonQuery();
                }
            }

            Console.ReadKey();
        }
    }
}
