﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace CodeQualitySample02
{
    class Friend
    {
        public string FirstName;
        public string LastName;

        public Friend(string firstName, string lastName)
        {
            this.FirstName = firstName;
            this.LastName = lastName;
        }

        public string FullName { get => $"{LastName}, {FirstName}"; }
    }

    class Program
    {
        private static IList<Friend> myFriends = new List<Friend>();

        static void Main(string[] args)
        {
            AddFriend("", "");

            PrintFriends();

            Console.ReadKey();
        }

        static void AddFriend(string firstName, string lastName)
        {
            Debug.Assert(!String.IsNullOrEmpty(firstName), "Vorname darf nicht leer sein!");
            Debug.Assert(!String.IsNullOrEmpty(lastName), "Nachname darf nicht leer sein!");

            if (!String.IsNullOrEmpty(firstName) && !String.IsNullOrEmpty(lastName))
            {
                myFriends.Add(new Friend(firstName, lastName));
            }
            
        }

        static void PrintFriends()
        {
            foreach (var f in myFriends)
            {
                Console.WriteLine(f.FullName);
            }
        }
    }
}
