﻿using System;
using System.Collections.Generic;
using System.Diagnostics;

namespace DebuggerSample_07
{
    [DebuggerDisplay("Name: {FullName}")]
    class Person
    {
        public string FirstName;
        public string LastName;

        public Person(string first, string last)
        {
            this.FirstName = first;
            this.LastName = last;
        }

        public string FullName { get => $"{LastName}, {FirstName}"; }
    }

    class Program
    {
        static IList<Person> myFriends = new List<Person>();

        static void Main(string[] args)
        {
            AddFriend("", "");

            PrintFriends();

            Console.ReadKey();
        }

        static void AddFriend(string firstName, string lastName)
        {
            //Debug.Assert(!String.IsNullOrEmpty(firstName), "A valid string is required for the first name!");
            //Debug.Assert(!String.IsNullOrEmpty(lastName), "A valid string is required for the last name!");

            myFriends.Add(new Person(firstName, lastName));

        }

        static void PrintFriends()
        {
            foreach (var p in myFriends)
            {
                Console.WriteLine(p.FullName);
            }
        }
    }
}
