﻿using System;
using System.Windows.Forms;

namespace BruttoNettoRechner
{
    public partial class frmMainWindow : Form
    {
        public frmMainWindow()
        {
            InitializeComponent();
        }

        private void BtnSchliessen_Click(object sender, EventArgs e)
        {
            Application.Exit();
        }

        private void BtnBerechnen_Click(object sender, EventArgs e)
        {
            // Variablen für die Berechnung
            double netto, steuer, brutto;

            try
            {
                // Werte in double konvertieren
                netto = Convert.ToDouble(this.txtNetto.Text);
                steuer = Convert.ToDouble(this.txtSteuer.Text);

                // Bruttobetrag ausrechnen
                brutto = netto * ((100 + steuer) / 100);

                // TextBox mit Ergebnis füllen
                this.txtBrutto.Text = brutto.ToString();
            }
            catch (FormatException ex)
            {
                string message = "Mindestens eine Ihrer Eingaben ist nicht numerisch!";
                message += $"{Environment.NewLine} Fehler: {Environment.NewLine}";
                message += ex.ToString();
                MessageBox.Show(message, "Fehler!");
            }
        }
    }
}
