﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using WpfMVVMSample01.Model;

namespace WpfMVVMSample01.Services
{
    public class PLZService
    {
        private string fileName = @".\Services\zuordnung_plz_ort_landkreis.csv";

        public IList<Postleitzahl> GetPostleitzahlen()
        {
            string[] csvlines = File.ReadAllLines(fileName);

            var query = from csvline in csvlines
                        let data = csvline.Split(',')
                        select new Postleitzahl()
                        {
                            ID = Convert.ToInt32(data[0]),
                            Ort = data[2],
                            PLZ = data[3],
                            Landkreis = data[4],
                            Bundesland = data[5]
                        };

            return query.ToList();
        }
    }
}
