﻿using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Windows.Input;
using WpfMVVMSample01.Base;
using WpfMVVMSample01.Commands;
using WpfMVVMSample01.Model;
using WpfMVVMSample01.Services;

namespace WpfMVVMSample01.ViewModel
{
    public class MainWindowViewModel : BindableBase
    {
        private PLZService plzService = new PLZService();

        public MainWindowViewModel()
        {
            this.Postleitzahlen = this.plzService.GetPostleitzahlen();
            this.SelectedPLZ = this.Postleitzahlen[0];

            this.InitCommands();
        }

        private void InitCommands()
        {
            this.ShowInGoogleMapsCommand = new ShowInGoogleMapsCommand();
        }

        public ICommand ShowInGoogleMapsCommand { get; private set; }

        private IList<Postleitzahl> postleitzahlen;

        /// <summary>
        /// Liste mit den Postleitzahlen
        /// </summary>
        public IList<Postleitzahl> Postleitzahlen
        {
            get { return postleitzahlen; }
            set
            {
                this.SetProperty(ref postleitzahlen, value);
            }
        }

        private Postleitzahl selectedPLZ;

        /// <summary>
        /// Selektierte Postleitzahl
        /// </summary>
        public Postleitzahl SelectedPLZ
        {
            get { return selectedPLZ; }
            set
            {
                this.SetProperty(ref selectedPLZ, value);
            }
        }
    }
}
