﻿using ModularApplicationSample.Core.Constants;
using ModularApplicationSample.Infrastructure.Interfaces;
using ModularApplicationSample.PLZ.Services;
using ModularApplicationSample.PLZ.Views;
using Prism.Ioc;
using Prism.Modularity;
using Prism.Regions;

namespace ModularApplicationSample.PLZ
{
    public class PLZModule : IModule
    {
        public void OnInitialized(IContainerProvider containerProvider)
        {
            // Den registrieten View mit den Kacheln in der Übersicht anzeigen (in Region PLZTiles)
            containerProvider.Resolve<IRegionManager>().RequestNavigate(RegionNames.TileRegion, "PLZTiles");
        }

        public void RegisterTypes(IContainerRegistry containerRegistry)
        {
            // Services registrieren
            containerRegistry.RegisterInstance<IPLZManagementService>(new PLZManagementService());

            //containerRegistry.Register(typeof(IPLZManagementService), typeof(PLZManagementService), "PLZManagementService");
            //containerRegistry.Register<IPLZManagementService, PLZManagementService>("PLZManagementService");

            // View mit der Kachelübersicht registrieren
            containerRegistry.RegisterForNavigation<Tiles>("PLZTiles");
            // View für Anzeige der Postleitzahlen
            containerRegistry.RegisterForNavigation<PLZManagement>("PLZManagement");            
        }
    }
}