﻿using ModularApplicationSample.Infrastructure.Interfaces;
using ModularApplicationSample.Infrastructure.Model;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;

namespace ModularApplicationSample.PLZ.Services
{
    public class PLZManagementService : IPLZManagementService
    {
        private string fileName = @".\Data\zuordnung_plz_ort_landkreis.csv";

        public PLZManagementService()
        {
            this.CSVLines = File.ReadAllLines(fileName);
        }

        public IList<Postleitzahl> GetAllPLZ()
        {
            var query = from csvline in this.CSVLines
                        let data = csvline.Split(',')
                        select new Postleitzahl()
                        {
                            Id = Convert.ToInt32(data[0]),
                            Ort = data[2],
                            PLZ = data[3],
                            Landkreis = data[4],
                            Bundesland = data[5]
                        };

            return query.ToList();
        }

        public string[] CSVLines { get; private set; }
    }
}
