﻿using ModularApplicationSample.Core.Constants;
using Prism.Commands;
using Prism.Ioc;
using Prism.Mvvm;
using Prism.Regions;

namespace ModularApplicationSample.PLZ.ViewModels
{
    public class TilesViewModel : BindableBase
    {
        public TilesViewModel(IRegionManager regionManager)
        {
            this.RegionManager = regionManager;
            
            this.InitializeCommands();
        }

        private void InitializeCommands()
        {
            this.ShowPlzManagementViewCommand = new DelegateCommand(this.ShowPlzManagementViewCommandExecute, this.ShowPlzManagementViewCommandCanExecute);
        }

        public DelegateCommand ShowPlzManagementViewCommand { get; private set; }

        private bool ShowPlzManagementViewCommandCanExecute()
        {
            return true;
        }

        private void ShowPlzManagementViewCommandExecute()
        {
            this.RegionManager.RequestNavigate(RegionNames.MainRegion, "PLZManagement");
        }

        public IRegionManager RegionManager { get; private set; }
    }
}
