﻿using System;
using System.IO;

namespace TryCatchFinallySample03
{
    class Program
    {
        static void Main(string[] args)
        {
            try
            {
                // Textdatei einlesen
                string text = File.ReadAllText(@"c:\ReadMe.txt");
                // Auf Konsole ausgeben
                Console.WriteLine("Der Text in der Datei lautet:");
                Console.WriteLine(text);
            }            
            catch (FileNotFoundException ex)
            {
                Console.WriteLine("Datei nicht gefunden!");
                Console.WriteLine(ex.Message);
            }
            catch (PathTooLongException ex)
            {
                Console.WriteLine("Der angegebene Pfad ist zu lang!");
                Console.WriteLine(ex.Message);
            }            
            catch (IOException ex)
            {
                Console.WriteLine("Allgemeiner Lesefehler!");
                Console.WriteLine(ex.Message);
            }
            catch (Exception ex)
            {
                Console.WriteLine("Fehler aufgetreten!");
                Console.WriteLine(ex.Message);
            }            
        }
    }
}
