﻿using System;
using System.IO;

namespace PathSample01
{
    class Program
    {
        static void Main(string[] args)
        {
            string path1 = @"c:\temp\MyTest.txt";
            string path2 = @"d:\";
            string path3 = @"e:\RootFolder\MySubfolder\AnotherSubfolder\file.txt";

            // Dateierweiterung ermitteln
            if (Path.HasExtension(path1))
            {
                Console.WriteLine($"{path1} hat die Erweiterung {Path.GetExtension(path1)}");
            }

            // Pfadangaben zusmamensetzen
            var tempPath = Path.Combine(path2, "MySubfolder", "MyTestFile.txt");
            Console.WriteLine($"Pfad: {tempPath}");

            // Pfandgaben extrahieren
            var fileName = Path.GetFileName(path3);
            var dirName = Path.GetDirectoryName(path3);

            Console.WriteLine($"Dateiname: {fileName}");
            Console.WriteLine($"Verzeichnis: {dirName}");

            // Ausgabe:
            // c:\temp\MyTest.txt hat die Erweiterung .txt.
            // Pfad: d:\MySubfolder\MyTestFile.txt
            // Dateiname: file.txt
            // Verzeichnis: e:\RootFolder\MySubfolder\AnotherSubfolder
        }
    }
}
